<template>
	<a-card :bordered="false" style="margin-bottom: 10px" class="mb-2">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form">
			<a-row :gutter="24">
				<a-col :span="6">
					<a-form-item label="车牌号" name="licensePlate">
						<a-input v-model:value="searchFormState.licensePlate" placeholder="请输入车牌号" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-form-item label="司机姓名" name="driverName">
						<a-input v-model:value="searchFormState.driverName" placeholder="请输入司机姓名" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-form-item label="司机电话" name="driverMobile">
						<a-input v-model:value="searchFormState.driverMobile" placeholder="请输入司机电话" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="tableRef.refresh()">查询</a-button>
					<a-button style="margin: 0 8px" @click="reset">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
	</a-card>
	<a-card :bordered="false">
		<s-table
			ref="tableRef"
			:columns="columns"
			:data="loadData"
			bordered
			:row-key="(record) => record.id"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('bizVehicleAdd')">
						<template #icon><plus-outlined /></template>
						新增
					</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('bizVehicleEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['bizVehicleEdit', 'bizVehicleDelete'], 'and')" />
						<a-button type="link" danger size="small" v-if="hasPerm('bizVehicleDelete')" @click="deleteConfig(record)">删除</a-button>
					</a-space>
				</template>
				<template v-if="column.dataIndex === 'status'">
					<span v-if="record.status=='1'">启用</span>
					<span v-else>关闭</span>
				</template>
				<template v-if="column.dataIndex === 'vehicleAxleNumber'">
					{{record.vehicleAxleNumber + '轴'}}
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="tableRef.refresh()" />
</template>

<script setup name="bizvehicle">
	import { cloneDeep } from 'lodash-es'
	import Form from './form.vue'
	import bizVehicleApi from '@/api/biz/bizVehicleApi'
	import {ExclamationCircleOutlined} from '@ant-design/icons-vue';
	import {Modal} from 'ant-design-vue';
	import {createVNode} from 'vue';

	const submitLoading = ref(false)
	const tableRef = ref()
	const formRef = ref()
	const toolConfig = { refresh: true, height: true, columnSetting: true, striped: false }

	//查询数据
	const searchFormState = ref({})
	const searchFormRef = ref()

	const columns = [
		{
			title: '车牌号',
			dataIndex: 'licensePlate',
			align:'center'
		},
		{
			title: '车辆轴数',
			dataIndex: 'vehicleAxleNumber',
			align:'center'
		},
		{
			title: '司机姓名',
			dataIndex: 'driverName',
			align:'center'
		},
		{
			title: '司机电话',
			dataIndex: 'driverMobile',
			align:'center'
		},
		{
			title: '状态',
			dataIndex: 'status',
			align:'center'
		},
	]
	// 操作栏通过权限判断是否显示
	if (hasPerm(['bizVehicleEdit', 'bizVehicleDelete'])) {
		columns.push({
			title: '操作',
			dataIndex: 'action',
			align: 'center',
			width: 150
		})
	}
	const selectedRowKeys = ref([])
	// 列表选择配置
	const options = {
		// columns数字类型字段加入 needTotal: true 可以勾选自动算账
		alert: {
			show: true,
			clear: () => {
				selectedRowKeys.value = ref([])
			}
		},
		rowSelection: {
			onChange: (selectedRowKey, selectedRows) => {
				selectedRowKeys.value = selectedRowKey
			}
		}
	}
	const loadData = (parameter) => {
		const searchFormParam = cloneDeep(searchFormState.value)
		return bizVehicleApi.bizVehiclePage(Object.assign(parameter, searchFormParam)).then((data) => {
			return data
		})
	}
	// 重置
	const reset = () => {
		searchFormRef.value.resetFields()
		tableRef.value.refresh(true)
	}
	// 删除
	const deleteBizVehicle = (record) => {
		let params = [
			{
				id: record.id
			}
		]
		bizVehicleApi.bizVehicleDelete(params).then(() => {
			tableRef.value.refresh(true)
		})
	}
	// 删除
	const deleteConfig = (record) => {

		Modal.confirm({
			title: '确定删除该数据吗？',
			icon: createVNode(ExclamationCircleOutlined),
			content: '',
			onOk() {
				submitLoading.value = true
				let params = [
					{
						id: record.id
					}
				]

				bizVehicleApi
					.bizVehicleDelete(params)
					.then(() => {
						tableRef.value.refresh(true)
					})
					.finally(() => {
						submitLoading.value = false
					})
			},
			onCancel() {}
		})
	}
	// 批量删除
	const deleteBatchBizVehicle = (params) => {
		bizVehicleApi.bizVehicleDelete(params).then(() => {
			tableRef.value.clearRefreshSelected()
		})
	}
</script>
